;      3- LED;
;    

;R2- 
;R3- 
;R4- 
;R5- 

;R6- 
;R7- 
;R8- 
;R9- 

; 01.01.2021

.include "m16def.inc"

.equ	Fo=1000000

.def DC=R18
.def _FF =R14 ;FF
;**********************************************************
.cseg
.org 0x0000
	CLR	ZH			;     0
	LDI	R16,0b11111111
	MOV	_FF,R16

	OUT	SPH,ZH
	OUT	SPL,R16		;  

;	LDI	ZL,$30
;	ST	Z+,_FF
;	CPI	ZL,$3B
;	BRLO	PC-2	

	LDI	R16,0b11111100
	OUT	DDRA,R16

	OUT	PORTB,_FF	;  1   
	OUT	PORTC,_FF	;  1  
	OUT	PORTD,_FF	;  1  
	OUT	DDRB,_FF
	OUT	DDRC,_FF	;   C   1  
	OUT	DDRD,_FF

	LDI	ZL,2
	ST	Z+,_FF
	CPI	ZL,10
	BRLO	PC-2	
	RJMP	START
;**********************************************************
.org 0x001C
ADComplete:
	IN	XL,ADCL
	IN	XH,ADCH

	OUT	PORTB,_FF
	OUT	PORTC,_FF	;    
	OUT	PORTD,_FF	;  

	ADD	R22,XL
	ADC	R21,XH
	ADC	R20,ZH
	INC	R23
	BRNE	INDIC
	SET

;*************************************************
INDIC:
	LDI	ZL,LOW(TB_DC*2)
	MOV	R16,DC
	LSL	R16
	ADD	ZL,R16
	LPM	R0,Z+			;   R0,R1
	LPM	R1,Z

	LDI	ZL,2		;   ZH,ZL  R2
	ADD	ZL,DC
	LD	R16,Z		;   R2...R9  R16
POINT:	
	OUT	PORTC,R0
	OUT	PORTD,R1
	OUT	PORTB,R16	;   
IND:
;     
	INC	DC
	CPI	DC,8
	BRLO	PC+2
	CLR	DC
	RETI
;*************************************************
; -   PB
TB_DIG:
	;     edpcgbaf   edpcgbaf
	.db 0b00001000,0b11001011 ;01
	.db 0b00010001,0b10000001 ;23
	.db 0b11000010,0b10000100 ;45
	.db 0b00000100,0b11001000 ;67
	.db 0b00000000,0b10000000 ;89
	.db 0b11111111,0b11111111 ;  
;   
TB_DC:
;	  PC		  PD
	.db 0b11111111,		0b11111111
;	  PC	  PD
	.db 0b11111111,		0b01111111
;	  PC	  PD
	.db 0b11111110,		0b11111111
;	  PC	  PD
	.db 0b11111101,		0b11111111

;	  PC	  PD
	.db 0b11111111,		0b11111111
;	  PC	  PD
	.db 0b11111011,		0b11111111
;	  PC	  PD
	.db 0b11110111,		0b11111111
;	  PC	  PD
	.db 0b11101111,		0b11111111
;******************************************
START:
	LDI	R16,1<<REFS1|1<<REFS0|1<<MUX0	; 
	OUT	ADMUX,R16
GO:
	LDI	R17,1
	IN	R16,ADMUX
	EOR	R16,R17
	OUT	ADMUX,R16

	SBI	ACSR,ACD	;   

	LDI	R16,1<<JTD
	OUT	MCUCSR,R16	;   JTAG

	CLR	DC
	
	LDI	R16,1<<SE		;|1<<SM0  ADC Noise Reduction mode
	OUT	MCUCR,R16		;  IDLE

	CLR	R20
	CLR	R21
	CLR	R22
	CLR	R23

	LDI	R16,1<<ADIE|1<<ADIF|1<<ADEN|1<<ADPS2|1<<ADPS0	; Fo/32
	OUT	ADCSRA,R16

	SEI 			;  /
WAIT:
	SBI	ADCSRA,ADSC
	SLEEP
	BRTC	WAIT
	CLI
	CLT	

	LSL	R22
	ADC	R21,ZH
	ADC	R20,ZH
	MOV	XH,R20
	MOV	XL,R21
;*****
BIN8_BCD3:
	SER	R20
	MOV	R10,R20
	MOV	R11,R20
	MOV	R12,R20

PMAX_R10_1000:
	INC	R10
	SUBI	XL,LOW(1000)
	SBCI	XH,HIGH(1000)
	BRCC	PMAX_R10_1000

	SUBI	XL,LOW(-1000)
	SBCI	XH,HIGH(-1000)
PMAX_R11_100:
	INC	R11
	SUBI	XL,LOW(100)
	SBCI	XH,HIGH(100)
	BRCC	PMAX_R11_100

	SUBI	XL,LOW(-100)
	SBCI	XH,HIGH(-100)
PMAX_R12_10:
	INC	R12
	SUBI	XL,LOW(10)
	SBCI	XH,HIGH(10)
	BRCC	PMAX_R12_10

	SUBI	XL,LOW(-10)
	SBCI	XH,HIGH(-10)

	MOV	R13,XL
;  
	LDI	R19,10
	TST		R10
	BRNE	DIG_OUT
	MOV	R10,R19
	TST		R11
	BRNE	DIG_OUT
	MOV	R11,R19

DIG_OUT:
;***
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R10
	LPM	R10,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R11
	LPM	R11,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R12
	LPM	R12,Z
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R13
	LPM	R13,Z

	LDI	ZL,2
	SBIC	ADMUX,MUX0
	LDI	ZL,6
	ST	Z+,R10
	ST	Z+,R11
	ST	Z+,R12
	ST	Z+,R13
	RJMP	GO
;*************************************************
.EXIT
